spandsp: v27ter_rx.h File Reference

spandsp 0.0.6

v27ter_rx.h File Reference

Go to the source code of this file.

## Typedefs
typedef struct v27ter_rx_state_s | v27ter_rx_state_t

## Functions
v27ter_rx_state_t * | v27ter_rx_init (v27ter_rx_state_t *s, int bit_rate, put_bit_func_t put_bit, void *user_data)
| Initialise a V.27ter modem receive context.
int | v27ter_rx_restart (v27ter_rx_state_t *s, int bit_rate, int old_train)
| Reinitialise an existing V.27ter modem receive context.
int | v27ter_rx_release (v27ter_rx_state_t *s)
| Release a V.27ter modem receive context.
int | v27ter_rx_free (v27ter_rx_state_t *s)
| Free a V.27ter modem receive context.
logging_state_t * | v27ter_rx_get_logging_state (v27ter_rx_state_t *s)
| Get the logging context associated with a V.27ter modem receive context.
void | v27ter_rx_set_put_bit (v27ter_rx_state_t *s, put_bit_func_t put_bit, void *user_data)
| Change the put_bit function associated with a V.27ter modem receive context.
void | v27ter_rx_set_modem_status_handler (v27ter_rx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.27ter modem receive context.
| SPAN_DECLARE_NONSTD (int) v27ter_rx(v27ter_rx_state_t *s
| Process a block of received V.27ter modem audio samples.
int | v27ter_rx_equalizer_state (v27ter_rx_state_t *s, complexf_t **coeffs)
| Get a snapshot of the current equalizer coefficients.
float | v27ter_rx_carrier_frequency (v27ter_rx_state_t *s)
float | v27ter_rx_symbol_timing_correction (v27ter_rx_state_t *s)
float | v27ter_rx_signal_power (v27ter_rx_state_t *s)
void | v27ter_rx_signal_cutoff (v27ter_rx_state_t *s, float cutoff)
void | v27ter_rx_set_qam_report_handler (v27ter_rx_state_t *s, qam_report_handler_t handler, void *user_data)

## Variables
const int16_t | amp []
const int16_t int | len

## Typedef Documentation

## ◆ v27ter_rx_state_t

typedef struct v27ter_rx_state_s v27ter_rx_state_t

V.27ter modem receive side descriptor. This defines the working state for a single instance of a V.27ter modem receiver.

## Function Documentation

## ◆ SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Process a block of received V.27ter modem audio samples.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Get the next bit of a transmitted serial bit stream.

Fake processing of a missing block of received V.27ter modem audio samples.

Process a block of received V.27ter modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Returns
  The number of samples unprocessed.

Fake processing of a missing block of received V.27ter modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

## ◆ v27ter_rx_carrier_frequency()

float v27ter_rx_carrier_frequency | ( | v27ter_rx_state_t * | s | ) |

Get the current received carrier frequency.

Parameters

  s | The modem context.

Returns
  The frequency, in Hertz.

References v27ter_rx_state_s::carrier_phase_rate, and dds_frequencyf().

## ◆ v27ter_rx_equalizer_state()

int v27ter_rx_equalizer_state | ( | v27ter_rx_state_t * | s,
|  | complexf_t ** | coeffs )

Get a snapshot of the current equalizer coefficients.

Get a snapshot of the current equalizer coefficients.

Parameters

  coeffs | The vector of complex coefficients.

Returns
  The number of coefficients in the vector.

References v27ter_rx_state_s::eq_coeff.

## ◆ v27ter_rx_free()

int v27ter_rx_free | ( | v27ter_rx_state_t * | s | ) |

Free a V.27ter modem receive context.

Free a V.27ter modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v27ter_rx_get_logging_state()

logging_state_t * v27ter_rx_get_logging_state | ( | v27ter_rx_state_t * | s | ) |

Get the logging context associated with a V.27ter modem receive context.

Get the logging context associated with a V.27ter modem receive context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v27ter_rx_state_s::logging.

## ◆ v27ter_rx_init()

v27ter_rx_state_t * v27ter_rx_init | ( | v27ter_rx_state_t * | s,
|  | int | bit_rate,
|  | put_bit_func_t | put_bit,
|  | void * | user_data )

Initialise a V.27ter modem receive context.

Initialise a V.27ter modem receive context.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 2400 and 4800.
  put_bit | The callback routine used to put the received data.
  user_data | An opaque pointer passed to the put_bit routine.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References v27ter_rx_state_s::logging, v27ter_rx_state_s::put_bit, v27ter_rx_state_s::put_bit_user_data, v27ter_rx_restart(), and v27ter_rx_signal_cutoff().

## ◆ v27ter_rx_release()

int v27ter_rx_release | ( | v27ter_rx_state_t * | s | ) |

Release a V.27ter modem receive context.

Release a V.27ter modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v27ter_rx_restart()

int v27ter_rx_restart | ( | v27ter_rx_state_t * | s,
|  | int | bit_rate,
|  | int | old_train )

Reinitialise an existing V.27ter modem receive context.

Reinitialise an existing V.27ter modem receive context.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 2400 and 4800.
  old_train | TRUE if a previous trained values are to be reused.

Returns
  0 for OK, -1 for bad parameter

References v27ter_rx_state_s::agc_scaling, v27ter_rx_state_s::agc_scaling_save, v27ter_rx_state_s::baud_half, v27ter_rx_state_s::bit_rate, v27ter_rx_state_s::carrier_drop_pending, CARRIER_NOMINAL_FREQ, v27ter_rx_state_s::carrier_phase, v27ter_rx_state_s::carrier_phase_rate, v27ter_rx_state_s::carrier_phase_rate_save, v27ter_rx_state_s::carrier_track_i, v27ter_rx_state_s::carrier_track_p, v27ter_rx_state_s::constellation_state, v27ter_rx_state_s::diff_angles, v27ter_rx_state_s::eq_skip, v27ter_rx_state_s::gardner_integrate, v27ter_rx_state_s::gardner_step, v27ter_rx_state_s::high_sample, v27ter_rx_state_s::last_sample, v27ter_rx_state_s::logging, v27ter_rx_state_s::low_samples, v27ter_rx_state_s::old_train, v27ter_rx_state_s::power, power_meter_init(), v27ter_rx_state_s::rrc_filter, v27ter_rx_state_s::rrc_filter_step, v27ter_rx_state_s::scramble_reg, v27ter_rx_state_s::scrambler_pattern_count, v27ter_rx_state_s::signal_present, span_log(), v27ter_rx_state_s::total_baud_timing_correction, v27ter_rx_state_s::training_bc, v27ter_rx_state_s::training_count, v27ter_rx_state_s::training_error, and v27ter_rx_state_s::training_stage.

Referenced by v27ter_rx_init().

## ◆ v27ter_rx_set_modem_status_handler()

void v27ter_rx_set_modem_status_handler | ( | v27ter_rx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.27ter modem receive context.

Change the modem status report function associated with a V.27ter modem receive context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v27ter_rx_state_s::status_handler, and v27ter_rx_state_s::status_user_data.

## ◆ v27ter_rx_set_put_bit()

void v27ter_rx_set_put_bit | ( | v27ter_rx_state_t * | s,
|  | put_bit_func_t | put_bit,
|  | void * | user_data )

Change the put_bit function associated with a V.27ter modem receive context.

Change the put_bit function associated with a V.27ter modem receive context.

Parameters

  s | The modem context.
  put_bit | The callback routine used to handle received bits.
  user_data | An opaque pointer.

References v27ter_rx_state_s::put_bit, and v27ter_rx_state_s::put_bit_user_data.

## ◆ v27ter_rx_set_qam_report_handler()

void v27ter_rx_set_qam_report_handler | ( | v27ter_rx_state_t * | s,
|  | qam_report_handler_t | handler,
|  | void * | user_data )

Set a handler routine to process QAM status reports

Parameters

  s | The modem context.
  handler | The handler routine.
  user_data | An opaque pointer passed to the handler routine.

References v27ter_rx_state_s::qam_report, and v27ter_rx_state_s::qam_user_data.

## ◆ v27ter_rx_signal_cutoff()

void v27ter_rx_signal_cutoff | ( | v27ter_rx_state_t * | s,
|  | float | cutoff )

Set the power level at which the carrier detection will cut in

Parameters

  s | The modem context.
  cutoff | The signal cutoff power, in dBm0.

References v27ter_rx_state_s::carrier_off_power, v27ter_rx_state_s::carrier_on_power, and power_meter_level_dbm0().

Referenced by v27ter_rx_init().

## ◆ v27ter_rx_signal_power()

float v27ter_rx_signal_power | ( | v27ter_rx_state_t * | s | ) |

Get a current received signal power.

Parameters

  s | The modem context.

Returns
  The signal power, in dBm0.

References v27ter_rx_state_s::power, and power_meter_current_dbm0().

## ◆ v27ter_rx_symbol_timing_correction()

float v27ter_rx_symbol_timing_correction | ( | v27ter_rx_state_t * | s | ) |

Get the current symbol timing correction since startup.

Parameters

  s | The modem context.

Returns
  The correction.

References v27ter_rx_state_s::bit_rate, and v27ter_rx_state_s::total_baud_timing_correction.